//   Process case convetsion of single file\director
//     ProcessName - convert case of given filename
//                   use all options from `Opt`
//                   Call recurse for subdirectories
void ProcessName(char *OldFullName, DWORD FileAttributes)
{
  char NewFullName[NM];
  char NewName[NM];
  char NewExt[NM];
  char *ExtPtr;

  lstrcpy(NewFullName, OldFullName);

  // Path
  ExtPtr = strrchr(NewFullName,'\\');
  if(ExtPtr)
    ExtPtr[1] = 0;
  else
    NewFullName[0] = 0;

  //Name
  strcpy(NewName,GetOnlyName(OldFullName));

  //Ext
  ExtPtr = strrchr(NewName,'.');

  if(ExtPtr)
  {
    ExtPtr[0] = 0; //delete extension from name
    strcpy(NewExt,ExtPtr+1);
  }
  else
    NewExt[0] = 0;

  if (*NewName==0 ||
     (*NewName=='.' && NewName[1]==0) ||
     (*NewName=='.' && NewName[1]=='.' && NewName[2]==0))
    return;

  //Check need to convert
  int mN = !Opt.SkipMixedCase || !IsCaseMixed(NewName);
  int mE = !Opt.SkipMixedCase || !IsCaseMixed(NewExt);
  int I  = mN + mE;
  
  //Case single file\dir
  if( ((I && Opt.ProcessSeparate) || (I == 2 && !Opt.ProcessSeparate)) &&
       (Opt.ProcessDir || (FileAttributes&FILE_ATTRIBUTE_DIRECTORY) == 0) )
  {
    switch(Opt.ConvertMode)
    {
      case MODE_N_WORD:
        if (mN)
          CaseWord(NewName,MODE_N_WORD);
        if (mE)
          CaseWord(NewExt,MODE_LOWER);
        break;
      case MODE_NE_WORD:
        if (mN)
          CaseWord(NewName,MODE_N_WORD);
        if (mE)
          CaseWord(NewExt,MODE_N_WORD);
        break;
      case MODE_LN_WORD:
        if (mN)
          CaseWord(NewName,MODE_LN_WORD);
        if (mE)
          CaseWord(NewExt,MODE_LOWER);
        break;
      case MODE_LNE_WORD:
        if(mN)
          CaseWord(NewName,MODE_LN_WORD);
        if(mE)
          CaseWord(NewExt,MODE_LN_WORD);
        break;
      case MODE_LOWER:
      case MODE_UPPER:
        if(mN)
          CaseWord(NewName,Opt.ConvertMode);
        if(mE)
          CaseWord(NewExt,Opt.ConvertMode);
        break;
    }

    strcat(NewFullName,NewName);

    if (NewExt[0])
    {
      strcat(NewFullName,".");
      strcat(NewFullName,NewExt);
    }
    MoveFile(OldFullName,NewFullName);
  }

  //Recurce to directories
  if( Opt.ProcessSubDir && (FileAttributes&FILE_ATTRIBUTE_DIRECTORY))
  {
    struct PluginPanelItem *PanelItems;
    int ItemsNumber,DirList;

    DirList = Info.GetDirList(OldFullName,&PanelItems,&ItemsNumber);

    if(DirList && ItemsNumber)
    {
      for (I=0; I < ItemsNumber; I++)
      {
        GetFullName(NewFullName,OldFullName,PanelItems[I].FindData.cFileName);
        ProcessName(NewFullName,PanelItems[I].FindData.dwFileAttributes);
      }
    }
    Info.FreeDirList(PanelItems);
  }
}
