#define WIN32_LEAN_AND_MEAN
#ifdef _MSC_VER
#pragma warning(disable : 4514)
#pragma warning(push,1)
#endif // _MSC_VER
#include <windows.h>
#include "plugin.hpp"
#ifdef _MSC_VER
#pragma warning(pop)
#endif // _MSC_VER

static FARAPIEDITORCONTROL EditorControl;

void WINAPI SetStartupInfo(const struct PluginStartupInfo *Info)
{
    EditorControl=Info->EditorControl;
}

int WINAPI ProcessEditorInput(const INPUT_RECORD *Rec)
{
    struct EditorInfo ei;
    struct EditorSetPosition esp;
    struct EditorGetString egs;
    struct EditorSelect es;
    int i;

    if( Rec->EventType==KEY_EVENT && Rec->Event.KeyEvent.bKeyDown &&
        (Rec->Event.KeyEvent.wVirtualKeyCode==VK_LEFT || Rec->Event.KeyEvent.wVirtualKeyCode==VK_RIGHT) ){
        if( !(Rec->Event.KeyEvent.dwControlKeyState & (LEFT_ALT_PRESSED|LEFT_CTRL_PRESSED|RIGHT_ALT_PRESSED|RIGHT_CTRL_PRESSED|SHIFT_PRESSED)) ){
            // correct jum to end/begin of block
            EditorControl(ECTL_GETINFO,&ei);
            if( !(ei.Options & EOPT_PERSISTENTBLOCKS) && ei.BlockType!=BTYPE_NONE ){
                esp.CurTabPos=-1;
                esp.TopScreenLine=-1;
                esp.Overtype=-1;
                esp.LeftPos=-1;
                esp.CurPos=-1;
                esp.CurLine=ei.BlockStartLine;
                if( Rec->Event.KeyEvent.wVirtualKeyCode==VK_LEFT ){
                    EditorControl(ECTL_SETPOSITION,&esp);
                    egs.StringNumber=-1;
                    EditorControl(ECTL_GETSTRING,&egs);
                    esp.CurPos=egs.SelStart;
                    esp.CurLine=-1;
                }else{ // right
                    for( egs.StringNumber=ei.CurLine; EditorControl(ECTL_GETSTRING,&egs); egs.StringNumber++ ){
                        if( egs.SelStart==-1 )break;
                        else i=egs.SelEnd;
                    }
                    esp.CurLine=egs.StringNumber-1;
                    esp.CurPos=i;
                }
                EditorControl(ECTL_SETPOSITION,&esp);
                es.BlockType=BTYPE_NONE;
                EditorControl(ECTL_SELECT,&es);
                return TRUE;
            }
        }else{
            // scroll viewpoint left/right
            if( !(Rec->Event.KeyEvent.dwControlKeyState & (LEFT_CTRL_PRESSED|RIGHT_CTRL_PRESSED)) &&
                 (Rec->Event.KeyEvent.dwControlKeyState & (LEFT_ALT_PRESSED|RIGHT_ALT_PRESSED)) &&
                 (Rec->Event.KeyEvent.dwControlKeyState & SHIFT_PRESSED) ){
                EditorControl(ECTL_GETINFO,&ei);
                esp.CurTabPos=-1;
                esp.TopScreenLine=-1;
                esp.Overtype=-1;
                esp.CurLine=-1;
                esp.CurPos=ei.CurPos;
                esp.LeftPos=ei.LeftPos;
                if( Rec->Event.KeyEvent.wVirtualKeyCode==VK_LEFT ){
                    if( esp.LeftPos )esp.LeftPos--;
                    if( esp.CurPos )esp.CurPos--;
                }else{ //right
                    if( !(ei.Options & EOPT_CURSORBEYONDEOL) ){
                        egs.StringNumber=-1;
                        EditorControl(ECTL_GETSTRING,&egs);
                        if( egs.StringLength > esp.CurPos )esp.CurPos++;
                    }else esp.CurPos++;
                    if( esp.CurPos < esp.LeftPos+ei.WindowSizeX ) esp.LeftPos++;
                }
                EditorControl(ECTL_SETPOSITION,&esp);
                if( !(ei.Options & EOPT_PERSISTENTBLOCKS) && ei.BlockType!=BTYPE_NONE ){
                    es.BlockType=BTYPE_NONE;
                    EditorControl(ECTL_SELECT,&es);
                }
                EditorControl(ECTL_REDRAW,NULL);
                return TRUE;
            }
        }
    }
    return FALSE;
}

