HKEY CreateRegKey(void)
{
  HKEY hKey;
  DWORD Disposition;
  static char FullKeyName[512];
  lstrcpy(FullKeyName,PluginRootKey);
  RegCreateKeyEx(HKEY_CURRENT_USER,FullKeyName,0,NULL,0,KEY_WRITE,NULL,&hKey,&Disposition);
  return(hKey);
}

HKEY OpenRegKey(void)
{
  HKEY hKey;
  static char FullKeyName[512];
  lstrcpy(FullKeyName,PluginRootKey);
  if (RegOpenKeyEx(HKEY_CURRENT_USER,FullKeyName,0,KEY_QUERY_VALUE,&hKey)!=ERROR_SUCCESS)
    return(NULL);
  return(hKey);
}

void SetRegKey(const char *ValueName,DWORD ValueData)
{
  HKEY hKey=CreateRegKey();
  RegSetValueEx(hKey,ValueName,0,REG_DWORD,(BYTE *)&ValueData,sizeof(ValueData));
  RegCloseKey(hKey);
}

int GetRegKey(const char *ValueName,int *ValueData,DWORD Default)
{
  HKEY hKey=OpenRegKey();
  DWORD Type,Size=sizeof(*ValueData);
  int ExitCode=RegQueryValueEx(hKey,ValueName,0,&Type,(BYTE *)ValueData,&Size);
  RegCloseKey(hKey);
  if (hKey==NULL || ExitCode!=ERROR_SUCCESS)
  {
    *ValueData=Default;
    return(FALSE);
  }
  return(TRUE);
}
