#ifndef __FAR_PLUGIN_FILECASE
#define __FAR_PLUGIN_FILECASE

#include <fstdlib.h>

/**
   LANGUAGE CONSTANTS
*/
enum {
  MNull__,

  MOk,
  MCancel,
  MError,
  MPluginName,

  MSkip,
  MAll,

  MRenameTitle,
  MRename,
  MTo,
  MRenameFail,
  MProcessd,
  MFiles,

  MEGetList,
  MEFilesPanel,
  MENoFiles,
  MESave,
  MEOpen,
  MECancelled,
  MEAborted,
  MEOpenList,

  MHelp1,
  MHelp2,
  MHelp3,
  MHelp4,
  MHelp5,
  MHelp6,

  MLast__
};

/***
   TYPES OF CONVERSIONS
*/
#define csMODE_UPPER    3
#define csMODE_LN_WORD  4
#define csMODE_LNE_WORD 5

/***
   CONFIG
*/
struct Options {
  bool InformCancel;            //Show information if editing cancelled
  bool ConfirmCancelled;        //Show information when file loading terminated by user
  bool ConfirmResults;          //Show information about number of files succ renamed
  bool AlignOutputFiles;        //Align a list file names in two columns
};
extern Options Opt;

/***
   FUNCTIONS
*/
//[fr_Cfg.cpp]
     void ReadConfig( void );
     void SaveConfig( void );

//[fr_Rename.cpp]
     void DoAction( void );

#endif